/*
author>
            Matthias Hader (R/GA)
            Nick Coronges (R/GA)
            Jeff Baxter (R/GA) - Design
</author>
<company>NIKE</company>
<copyright>(c)2006 NIKE ALL RIGHTS RESERVED</copyright>
 */
//debug
var debugMode = false;
var testMode = false;
//live
var baseURL = "http://www.nike.com";
var baseURLssl = "https://www.nike.com";
//test
var baseURLsslTest = "http://nike-dev2.ny.rga.com";


//XML Http Requests 
var reqLogout;
var reqGeneratePin;
var reqGetToken;
var reqTokenLogin;
var reqGetChallenges;
var reqGetChallengeDetail;
var reqValidateWidget;

//session id
var g_bsessionid;

//widget validation information
var widgetName = "challengeDesktopWidget";
var widgetEngine = "MacOSDashboard";
var widgetVersion = "0.9";

//status of log in
var g_loggedIN = false;

function setup(){
	if(debugMode == true) document.getElementById('debug').style.display = "block";
	if(testMode == true) baseURLssl = baseURLsslTest;
	//load assets
	if (assetsLoaded == false) loadAssets();
	//mock
	//pin = "0075CE90-E776-D8E7-74B7-5178B7554F32";
	//hideDoneButton();
	//showLogoutButton();
	//flipSide('front','back','ToBack');
	//processGetTokenAndSessionID(pin);
	//end mock
	
	//get preferences if possible
	var username = "";
	if (window.widget){
		//get saved username and set it in the username field
		username = getUsernamePreference();
	}
	document.getElementById("usernameField").value = username;
	
	var pin = "";
	var challengeID="";
	if (window.widget){
		//fetch pin
		pin = getPinPreference();
		//fetch last viewed challenge
		challengeID = getLastChallengeIDPreference();
	}
	debug("setup pin pref:"+pin);
	debug("setup pin last challenge pref:"+challengeID);
	//proceed according to the preferences
	if(pin == ""){
		hideDoneButton();
		flipSide('front','back','ToBack');
	}
	else if (challengeID == ""){
		hideDoneButton();
		showLogoutButton();
		flipSide('front','back','ToBack');
		debug("last challenge was empty! get token and session");
		processGetTokenAndSessionID(pin);
	}
	else{
		debug("show done button and get token and session");
		showLogoutButton();
		processGetTokenAndSessionID(pin);	
	}
}

function validateWidget(){
    //notifyLoadingSequenceStart();
    serviceURL = baseURL + "/nikeplus/v1/services/widget/check_version.jhtml";
    var product = widgetName+"_"+widgetEngine+"_v"+widgetVersion;
    reqValidateWidget = new XMLHttpRequest();
    reqValidateWidget.onreadystatechange = processReqValidateChange;
    reqValidateWidget.open("POST", serviceURL, true);
    reqValidateWidget.send("product="+product);
}
 
function processReqValidateChange(){
    //notifyLoadingSequenceStop();
	if (reqValidateWidget.readyState == 4) {
	    if (reqValidateWidget.status == 200) {
			var allResponseHeaders = reqValidateWidget.getAllResponseHeaders();
			temp_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
			if(temp_bsessionid != ""){
				g_bsessionid = temp_bsessionid;
			} 
			debug("validate bsessionid: "+g_bsessionid);
	        var serviceStatus =  reqValidateWidget.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
	            isCurrentVersion =  reqValidateWidget.responseXML.getElementsByTagName("isCurrentVersion")[0].firstChild.data;
				if(isCurrentVersion == "true"){
					setup();
	            }
	            else{
	                flipSide('front','back','ToBack');
	                downloadLink =  reqValidateWidget.responseXML.getElementsByTagName("downloadLink")[0].firstChild.data;
	                forceUpgrade = reqValidateWidget.responseXML.getElementsByTagName("forceUpgrade")[0].firstChild.data;
	                serviceMessage =  reqValidateWidget.responseXML.getElementsByTagName("message")[0].firstChild.data;
	                if(forceUpgrade == "true"){
                        popUpMessageBoxWithLink(false,serviceMessage,downloadLink);
	                }
	                else{
                        popUpMessageBoxWithLink(true,serviceMessage,downloadLink);
	                }
	            }
	        }
	        else{
                popUpMessageBox(true,"We just can't connect right now. Try again later.");
	        }
	    }
	    else{
            popUpMessageBox(true,"We just can't connect right now. Try again later.");
	    }
	}
	else if(reqValidateWidget.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
	}
}

function processLogout(){
	serviceURL = baseURLssl + "/services/profileService?action=logout";
	reqLogout = new XMLHttpRequest();
	reqLogout.onreadystatechange = processReqLogout;
	if(g_bsessionid != "") reqLogout.setRequestHeader("Cookie", g_bsessionid);
	reqLogout.open("POST", serviceURL, true);
	reqLogout.send(null);
}

function processReqLogout(){
	if (reqLogout.readyState == 4) {
		if (reqLogout.status == 200) {
		}
	}
}

function processLogin(username,password){
	if((username != "") && (password != "")){
		//notifyLoadingSequenceStart();
		debug("process login: "+username+"/"+password);
		serviceURL = baseURLssl + "/nikeplus/v1/services/widget/generate_pin.jhtml";
		reqGeneratePin = new XMLHttpRequest();
	    reqGeneratePin.onreadystatechange = processReqGeneratePinChange; 
		if(g_bsessionid != "") reqGeneratePin.setRequestHeader("Cookie", g_bsessionid);
	    reqGeneratePin.open("POST", serviceURL, true);
	    reqGeneratePin.send("login="+username+"&password="+password);
	}
	else{
		popUpMessageBox(true,"You've got to log in to see your status, so enter your username and password.");
		showLoginButton();
	}
}


function processReqGeneratePinChange(){
	if (reqGeneratePin.readyState == 4) {
		if (reqGeneratePin.status == 200) {
			var serviceStatus =  reqGeneratePin.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
				var allResponseHeaders = reqGeneratePin.getAllResponseHeaders();
				temp_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
				if(temp_bsessionid != ""){
					g_bsessionid = temp_bsessionid;
				} 
				debug("generate pin bsessionid: "+g_bsessionid);
				var pin = reqGeneratePin.responseXML.getElementsByTagName("pin")[0].firstChild.data;
				debug("generate pin: "+pin);
				if (window.widget){
					setPinPreference(pin);
				}
				showLogoutButton();
				processGetToken(pin);
			}
			else{
                var errorCode =  reqGeneratePin.responseXML.getElementsByTagName("serviceException")[0].getAttribute("errorCode");
                popUpMessageBox(true,"Something wasn't quite right. Try entering your info again.");
                showLoginButton();
	        }
		}
		else{
			popUpMessageBox(true,"We just can't connect right now. Try again later.");
            showLoginButton();
		}
	}
	 else if(reqGeneratePin.readyState == 0){
	    popUpMessageBox(true,"We just can't connect right now. Try again later.");
	    showLoginButton();
    }
}

function processGetToken(pin){
	//notifyLoadingSequenceStart();
    serviceURL = baseURLssl + "/nikeplus/v1/services/widget/generate_token.jhtml";
    reqGetToken = new XMLHttpRequest();
    reqGetToken.onreadystatechange = processReqGetTokenChange;
    reqGetToken.open("POST", serviceURL, true);
    reqGetToken.setRequestHeader("pin", pin);
	reqGetToken.setRequestHeader("Cookie", g_bsessionid);
    reqGetToken.send(null);
}

function processReqGetTokenChange(){
	if (reqGetToken.readyState == 4) {
		if (reqGetToken.status == 200) {
			var serviceStatus =  reqGetToken.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
				var allResponseHeaders = reqGetToken.getAllResponseHeaders();
				if(g_bsessionid == "") g_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
				debug("get token bsessionid: "+g_bsessionid);
				var token = reqGetToken.responseXML.getElementsByTagName("token")[0].firstChild.data;
				debug("get token: "+token);
				processTokenLogin(token);
			}
			else{
				var errorCode =  reqGetToken.responseXML.getElementsByTagName("serviceException")[0].getAttribute("errorCode");
                popUpMessageBox(true,"Something wasn't quite right. Try entering your info again.");
			}
		}
		else{
			 popUpMessageBox(true,"We just can't connect right now. Try again later.");
		}
	}
	 else if(reqGetToken.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}

function processGetTokenAndSessionID(pin){
    serviceURL = baseURLssl + "/nikeplus/v1/services/widget/generate_token.jhtml";
    reqGetToken = new XMLHttpRequest();
    reqGetToken.onreadystatechange = processReqGetTokenAndSessionIDChange;
    reqGetToken.open("POST", serviceURL, true);
    reqGetToken.setRequestHeader("pin", pin);
    reqGetToken.send(null);
}

function processReqGetTokenAndSessionIDChange(){
	if (reqGetToken.readyState == 4) {
		if (reqGetToken.status == 200) {
			var serviceStatus =  reqGetToken.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
				var allResponseHeaders = reqGetToken.getAllResponseHeaders();
				temp_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
				if(temp_bsessionid != ""){
					g_bsessionid = temp_bsessionid;
				} 
				debug("get token bsessionid: "+g_bsessionid);
				var token = reqGetToken.responseXML.getElementsByTagName("token")[0].firstChild.data;
				debug("get token: "+token);
				processTokenLogin(token);
			}
			else{
				var errorCode =  reqGetToken.responseXML.getElementsByTagName("serviceException")[0].getAttribute("errorCode");
                popUpMessageBox(true,"Something wasn't quite right. Try entering your info again.");
			}
		}
		else{
			 popUpMessageBox(true,"We just can't connect right now. Try again later.");
		}
	}
	 else if(reqGetToken.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}


function processTokenLogin(token){
    serviceURL = baseURL + "/nikeplus/v1/services/widget/token_login.jhtml";
    reqTokenLogin = new XMLHttpRequest();
    reqTokenLogin.onreadystatechange = processReqTokenLoginChange;
    reqTokenLogin.open("POST", serviceURL, true);
	reqTokenLogin.setRequestHeader("Cookie", g_bsessionid);
    reqTokenLogin.send("token="+token);
}

function processReqTokenLoginChange(){
	if (reqTokenLogin.readyState == 4) {
		if (reqTokenLogin.status == 200) {
			debug("process get challenges");
			processGetChallenges();
		}
		else{
			popUpMessageBox(true,"We just can't connect right now. Try again later.");
        }
    }
    else if(reqTokenLogin.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}

function processGetChallenges(){
	serviceURL = baseURL + "/nikeplus/v1/services/widget/get_challenges_for_user.jhtml";
    reqGetChallenges = new XMLHttpRequest();
    reqGetChallenges.onreadystatechange = processReqGetChallengesChange;
    reqGetChallenges.open("POST", serviceURL, true);
	reqGetChallenges.setRequestHeader("Cookie", g_bsessionid);
    reqGetChallenges.send(null);
}

function processReqGetChallengesChange(){
	//notifyLoadingSequenceStop();
	if (reqGetChallenges.readyState == 4) {
		if (reqGetChallenges.status == 200) {
			var challenges = reqGetChallenges.responseXML;
			var html = getChallengeSelectBox(challenges);
			if(html != ""){
				document.getElementById("challengeSelectContainer").innerHTML = html;
				//if there is a last challengeID saved -> load it
				if(window.widget){
					lastChallengeID = getLastChallengeIDPreference();
					if( lastChallengeID != ""){
						processGetChallengeDetail(lastChallengeID);
					}
				}
				//show the challenge Selector
				showChallengeSelector();
			}
			else{
				popUpMessageBox(true,"You have to be in a Nike+ Challenge to see it here. Create one at nikeplus.com.");
			}
		}
		else{
			popUpMessageBox(true,"We just can't connect right now. Try again later.");
		}
	}
	else if(reqGetChallenges.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}

function processGetChallengeDetail(challengeID){
	debug("process get challenge detail:"+challengeID);
	serviceURL = baseURL + "/nikeplus/v1/services/widget/get_challenge_detail.jhtml";
    reqGetChallengeDetail = new XMLHttpRequest();
    reqGetChallengeDetail.onreadystatechange = processReqGetChallengeDetail;
    reqGetChallengeDetail.open("POST", serviceURL, true);
	reqGetChallengeDetail.setRequestHeader("Cookie", g_bsessionid);
    reqGetChallengeDetail.send("id="+challengeID);
}

function processReqGetChallengeDetail(){
	//notifyLoadingSequenceStop();
	if (reqGetChallengeDetail.readyState == 4) {
		if (reqGetChallengeDetail.status == 200) {
			var challengeNodeList =  reqGetChallengeDetail.responseXML.getElementsByTagName("challenge");
            debug("challengeNodeList: "+challengeNodeList);
			if(challengeNodeList == null){
				debug("challengeNodeList null! re-login");
                setup();
            }
            else{
                var challengeDetail = reqGetChallengeDetail.responseXML;
               	document.getElementById("challengeHeadlineContainer").innerHTML = getChallengeDetailHeadline(challengeDetail);
				document.getElementById("challengeDetailContainer").innerHTML = getChallengeDetail(challengeDetail);
				
            }
        }
        else{
            popUpMessageBox(true,"We just can't connect right now. Try again later.");
        }
	}
	else if(reqGetChallengeDetail.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
	}
}

function getChallengeDetail(challengeDetailDOM){
	//alert("get Challenege Detail");
	var html = "";
	var challengeMemberIterator = challengeDetailDOM.getElementsByTagName("member");
	var challengeType = challengeDetailDOM.getElementsByTagName("definition")[0].childNodes[1].firstChild.data;
	var comparatorValue = challengeDetailDOM.getElementsByTagName("definition")[0].childNodes[3].firstChild.data;
	var currentUserID = challengeDetailDOM.getElementsByTagName("currentUser")[0].parentNode.getAttribute("id");
	
	var sortedMembersArray = getSortedMembers(challengeMemberIterator);
	if(challengeType == "fastestRun") sortedMembersArray = getReverseSortedMembers(challengeMemberIterator);
	var leadersProgress = sortedMembersArray[0][1];
	for(var i=0;i<challengeMemberIterator.length;i++){
		var numberOfNodes = challengeDetailDOM.getElementsByTagName("member")[i].childNodes.length;
		var memberID = challengeDetailDOM.getElementsByTagName("member")[i].getAttribute("id");
		var progress = challengeDetailDOM.getElementsByTagName("member")[i].childNodes[1].firstChild.data;
		var screenName = "-";
		var isCurrentUser = false;
		if(memberID == currentUserID) isCurrentUser = true;
		var isWinner = isMemberWinner(challengeDetailDOM,memberID);
		
		
		if(challengeDetailDOM.getElementsByTagName("member")[i].childNodes[5].firstChild != null){
			screenName = challengeDetailDOM.getElementsByTagName("member")[i].childNodes[5].firstChild.data;
		}
		else {
			screenName = challengeDetailDOM.getElementsByTagName("member")[i].childNodes[3].firstChild.data;
		}
		//challenge Status is the last node of member...hence allNodesCount-2 (because every other node is a TextNode for the linebreak)
		var challengeStatus = challengeDetailDOM.getElementsByTagName("member")[i].childNodes[numberOfNodes-2].firstChild.data;
		var challengeDiv;
		//get rank
		var rank;
		for(var j=0;j<sortedMembersArray.length;j++){
			if(memberID == sortedMembersArray[j][0]){
				rank=j+1;
			}
		}
		containeroffset = (rank-1)*39;
		var rankText = rank;
		if(rank<10){
			rankText = "0"+rank;
		}
		if(challengeStatus != "confirmed"){
			challengeDiv = 	"<div id=\"challengerName\">"+rankText+" "+screenName+"</div>"+
							"<div class=\"progressBar\" id=\"progressBarBackground\"></div>"+
							"<div id=\"progressBarStatusText\">"+getMemberStatusText(challengeStatus.toLowerCase())+"</div>";
		}
		else if (progress == "0.0"){
			challengeDiv = 	"<div id=\"challengerName\">"+rankText+" "+screenName+"</div>"+
							"<div class=\"progressBar\" id=\"progressBarBackground\"></div>"+
							"<div id=\"progressBarStatusText\">NO RUNNING DATA</div>";
		}
		else{
			challengeDiv = 	"<div id=\"challengerName\">"+rankText+" "+screenName+"</div>";
			
			switch (challengeType){
				case "distanceRace": 
					challengeDiv += 
						"<div class=\"progressBar\" id=\"progressBarBackground\"></div>" +
						getProgressInformationDistanceLimit(progress,comparatorValue,isCurrentUser,isWinner);
					break;
				case "mostDistance": 
					challengeDiv += getProgessInformationDistanceTime(progress,leadersProgress,comparatorValue,isCurrentUser,isWinner);
					break;
				case "fastestRun": 
					challengeDiv += getProgressInformationDistanceFastest(progress,leadersProgress,comparatorValue,isCurrentUser,isWinner);
					break;
				case "teamDistance": 
					challengeDiv += 
						"<div class=\"progressBar\" id=\"progressBarBackground\"></div>" +
						getProgressInformationDistanceLimit(progress,comparatorValue,isCurrentUser,isWinner);
					break;
			}
		}
		
		html += "<div id=\"challengeMemberContainer\" style=\"position:absolute;left:0px;top:"+containeroffset+"\">"+challengeDiv+"</div>";
	}
	return html;
}

function getProgressInformationDistanceFastest(progress,leadersProgress,comparatorValue,isCurrentUser,isWinner){
	//show time as progress text
	//since progress is the time in millis and the leader has the least millis
	//calculate all runners as the ration of the leader.
	var maxProgress = 130;
	var progressBarWidth = maxProgress + 18;
	var progressRatio = leadersProgress/progress;
	var progressSectionWidth = Math.round(progressRatio*maxProgress);
	var progressEnd = progressSectionWidth + 9;
	if(progressSectionWidth > maxProgress) progressSectionWidth = maxProgress;
	var divLeft = progressSectionWidth + 20;
	var progressTextStyle = "color:#666666;left:"+divLeft+"px;text-align:left";
	
	if(isWinner==true){
		var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStartWinner\"></div>"+
		"<div id=\"progressBarStatusText\" style=\"color:#FFFFFF;width:"+progressBarWidth+"px\">WINNER!</div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getTimeInPrimeFormatFromMilliSeconds(progress)+"</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySectionsWinner\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEndWinner\" style=\"left:"+progressEnd+"px\"></div>";
		return progressInformationResult;
	}
	else if(isCurrentUser==true){
		var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStartUser\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getTimeInPrimeFormatFromMilliSeconds(progress)+"</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySectionsUser\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEndUser\" style=\"left:"+progressEnd+"px\"></div>";
		return progressInformationResult;
	}
	else{			
	 	var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStart\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getTimeInPrimeFormatFromMilliSeconds(progress)+"</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySections\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEnd\" style=\"left:"+progressEnd+"px\"></div>";
		return progressInformationResult;
	}
	//"<div class=\"progressBar\" id=\"progressBarProgressTimeText\" style=\"color:#999999;\">"+getTimeInPrimeFormatFromMilliSeconds(progress)+"</div>";
			
}

function getProgessInformationDistanceTime(progress,leadersProgress,comparatorValue,isCurrentUser,isWinner){
	//show distance as progress w/o a grey background bar and take most progress as relation for the distance graph
	var maxProgress = 116;
	var progressBarWidth = maxProgress + 18;
	var progressUnit = maxProgress/leadersProgress;
	var progressSectionWidth = Math.round(progress*progressUnit);
	var progressEnd = progressSectionWidth + 9;
	if(progressSectionWidth > maxProgress) progressSectionWidth = maxProgress;
	var divLeft = progressSectionWidth + 20;
	var progressTextStyle = "color:#666666;left:"+divLeft+"px;text-align:left";
	
	if(isWinner==true){
		var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStartWinner\"></div>"+
		"<div id=\"progressBarStatusText\" style=\"color:#FFFFFF;width:"+progressBarWidth+"px\">WINNER!</div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getMilesFromKM(progress,2)+" mi</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySectionsWinner\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEndWinner\" style=\"left:"+progressEnd+"px\"></div>";
		return progressInformationResult;
	}
	else if(isCurrentUser==true){
		var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStartUser\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getMilesFromKM(progress,2)+" mi</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySectionsUser\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEndUser\" style=\"left:"+progressEnd+"px\"></div>";
		return progressInformationResult;
	}
	else{			
	 	var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStart\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getMilesFromKM(progress,2)+" mi</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySections\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEnd\" style=\"left:"+progressEnd+"px\"></div>";
		return progressInformationResult;
	}
}


function getProgressInformationDistanceLimit(progress,comparatorValue,isCurrentUser,isWinner){
	
	//show distance as progress text with a grey background bar
	var maxProgress = 158;
	var progressUnit = 158/comparatorValue;
	var progressSectionWidth = Math.round(progress*progressUnit);
	if (progressSectionWidth > maxProgress) progressSectionWidth = maxProgress;
	var progressTextStyle = "color:#666666;width:45px";
	var progressWhiteLineLeft = progressSectionWidth+9;
	if (progressSectionWidth > 35){
		divWidth = progressSectionWidth + 7;
		progressTextStyle = "color:#FFFFFF;width:"+divWidth+"px";
	}
	else{
		divLeft = progressSectionWidth + 13;
		progressTextStyle = "color:#666666;left:"+divLeft+"px;text-align:left";
	}
	
	if(isWinner==true){
		var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStartWinner\"></div>"+
		"<div id=\"progressBarStatusText\" style=\"color:#FFFFFF\">WINNER!</div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getMilesFromKM(progress,2)+" mi</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySectionsWinner\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayEndWinner\"></div>";
		return progressInformationResult;
	}
	else if(isCurrentUser==true){
		var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStartUser\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getMilesFromKM(progress,2)+" mi</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySectionsUser\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayWhiteDelimiter\" style=\"left:"+progressWhiteLineLeft+"px\"></div>";
		return progressInformationResult;
	}
	else{			
	 	var progressInformationResult =
		"<div class=\"progressBar\" id=\"progressBarOverlayStart\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarProgressDistanceText\" style=\""+progressTextStyle+"\">"+getMilesFromKM(progress,2)+" mi</div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlaySections\" style=\"width:"+progressSectionWidth+"\"></div>"+
		"<div class=\"progressBar\" id=\"progressBarOverlayWhiteDelimiter\" style=\"left:"+progressWhiteLineLeft+"px\"></div>";
		return progressInformationResult;
	}
}

function getChallengeDetailHeadline(challengeDetailDOM){
	var challengeTitle = challengeDetailDOM.getElementsByTagName("challenge")[0].childNodes[1].firstChild.data;
	var endTime = challengeDetailDOM.getElementsByTagName("challenge")[0].childNodes[7].firstChild.data;
	var challengeType = challengeDetailDOM.getElementsByTagName("definition")[0].childNodes[1].firstChild.data;
	var comparatorValue = challengeDetailDOM.getElementsByTagName("definition")[0].childNodes[3].firstChild.data;
	var displayUnit = challengeDetailDOM.getElementsByTagName("definition")[0].childNodes[5].firstChild.data;
	
	var challengeSubtitle = getChallengeSubtitle(challengeType,endTime,comparatorValue,displayUnit);
	
	var html = "<div id=\"challengeTitleContainer\">"+challengeTitle+"</div><div id=\"challengeSubtitleContainer\">"+challengeSubtitle+"</div>";
	return html;
}

function getChallengeSubtitle(challengeType,endTime,comparatorValue,displayUnit){
	var subtitle = "";
	switch (challengeType){
		case "distanceRace": 
			subtitle = "First to run "+getSubtitleDistance(displayUnit,comparatorValue)+" "+displayUnit;
			break;
		case "mostDistance": 
			subtitle = "Most kilometers over "+Math.round(comparatorValue)+" days" ;
			break;
		case "fastestRun": 
			subtitle = "The fastest "+Math.round(getSubtitleDistance(displayUnit,comparatorValue))+" "+displayUnit+" run by "+ getParsedDateYYMMDD(endTime);
			break;
		case "teamDistance": 
			subtitle = "All challgengers run "+getSubtitleDistance(displayUnit,comparatorValue)+" "+displayUnit;
		break;
	}
	return subtitle;
}

function getSubtitleDistance(displayUnit,comparatorValue){
	if(displayUnit == "mi"){
		kmToMiles = comparatorValue / 1.609344;
		kmToMiles = setPrecision(kmToMiles+"",2);
		return kmToMiles;
	}
	else{
		km = setPrecision(comparatorValue,2);
		return km;
	}
}
/**
 * since it seems that the xml list is mostly almost reverse sorted,
 * i reverse order the list and use bubblesort (small list almost sorted)
 * @param {Object} challengeMemberIterator
 */
function getSortedMembers(challengeMemberIterator){
	var challengeMemberCount = challengeMemberIterator.length;
	challengerListArray = new Array(challengeMemberCount);
	for(var i=0;i<challengeMemberCount;i++){
		var challengeDetailArray = new Array(2);
		var memberID = challengeMemberIterator[(challengeMemberCount-1)-i].getAttribute("id");
		var progress = challengeMemberIterator[(challengeMemberCount-1)-i].childNodes[1].firstChild.data;
		challengeDetailArray[0] = memberID;
		challengeDetailArray[1] = progress;
		challengerListArray[i] = challengeDetailArray;
	}	
	var sortedArray = bubblesort2DimArray(challengerListArray,1);
	//for(var j=0;j<sortedArray.length;j++){
	//	alert(sortedArray[j][1]);
	//}
	return sortedArray;
}

/**
 * since it seems that the xml list is mostly almost reverse sorted,
 * i reverse order the list and use bubblesort (small list almost sorted).
 * Reverse sorted means that users whith progress > 0.0 are reverseSortes...others 
 * with 0.0 are added at the end. 
 * @param {Object} challengeMemberIterator
 */
function getReverseSortedMembers(challengeMemberIterator){
	var challengeMemberCount = challengeMemberIterator.length;
	challengerListArray = new Array(challengeMemberCount);
	for(var i=0;i<challengeMemberCount;i++){
		var challengeDetailArray = new Array(2);
		var memberID = challengeMemberIterator[(challengeMemberCount-1)-i].getAttribute("id");
		var progress = challengeMemberIterator[(challengeMemberCount-1)-i].childNodes[1].firstChild.data;
		challengeDetailArray[0] = memberID;
		challengeDetailArray[1] = progress;
		challengerListArray[i] = challengeDetailArray;
	}	
	var sortedArray = bubblesort2DimArray(challengerListArray,1);
	nullProgressArray = new Array();
	progressArray = new Array();
	for(var j=0;j<sortedArray.length;j++){
		if(parseInt(sortedArray[j][1]) == 0) nullProgressArray[nullProgressArray.length] = sortedArray[j];
		else progressArray[progressArray.length] = sortedArray[j];
	}
	reversedProgressArray = progressArray.reverse();
	reversedSortedArray = reversedProgressArray.concat(nullProgressArray);
	//alert(reversedProgressArray.length + " + "+nullProgressArray.length+" = " + reversedSortedArray.length);
	return reversedSortedArray;
}


function setStatusMessageInBackFlipSelectContainer(messageText){
	 document.getElementById("challengeSelectContainer").innerHTML = "<div id=\"backflipStatusMessage\">"+messageText+"</div>";
}

function getMemberStatusText(msgKey){
	switch(msgKey){
		case "pending":
			return "CONFIRMATION PENDING";
			break;
		case "denied":
			return "DECLINED";
			break;
		default:
			return msgKey.toUpperCase();
	}
}

function isMemberWinner(challengeDetailDOM,memberID){
	var winnerNodes = challengeDetailDOM.getElementsByTagName("winner");
	var isWinner = false;
	for(var i=0;i<winnerNodes.length;i++){
		winnerID = winnerNodes[i].parentNode.getAttribute("id");
		if(winnerID == memberID) isWinner=true;
	}
	return isWinner;
}

function openNikePlusWithToken(pin){
    serviceURL = "https://www.nike.com/nikeplus/v1/services/widget/generate_token.jhtml";
    reqGetToken = new XMLHttpRequest();
    reqGetToken.onreadystatechange = openNikePlusWithTokenChange;
    reqGetToken.open("POST", serviceURL, true);
    reqGetToken.setRequestHeader("pin", pin);
    reqGetToken.send(null);
}
 
function openNikePlusWithTokenChange(){
    if (reqGetToken.readyState == 4) {
        if (reqGetToken.status == 200) {
			debug("got token response to link to nike");
            var serviceStatus =  reqGetToken.responseXML.getElementsByTagName("status")[0].firstChild.data;
            if(serviceStatus == "success"){
                var token =  reqGetToken.responseXML.getElementsByTagName("token")[0].firstChild.data;
				debug(token);
				challengeID = getLastChallengeIDPreference();
                if(challengeID != ""){
                    widget.openURL("http://www.nike.com/nikeplus/?l=challenges,"+challengeID+"&token="+token);
                }
                else{
                    widget.openURL("http://www.nike.com/nikeplus/?token="+token);
                }
            }
            else{
                widget.openURL("http://www.nikeplus.com");
            }
        }
        else{
            widget.openURL("http://www.nikeplus.com");;
        }
    }
    else if(reqGetToken.readyState == 0){
        widget.openURL("http://www.nikeplus.com");
    }
}
